<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="beneficiaryHistoryPath"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomAlert
            v-if="fetchError"
            :alert-type="AlertType.Error"
            :message="fetchError"
          />

          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <InterviewForm
            v-else-if="beneficiary && followUpTypes && prescribingOrganisations"
            :is-submitting="isSubmitting"
            :follow-up-types="followUpTypes"
            :beneficiary-id="beneficiaryId"
            :prescribing-organisations="prescribingOrganisations"
            @save-interview="onSaveInterview"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { beneficiaryName } from '~/utils/beneficiary'
  import { HISTORY_TAB } from '~/utils/constants/beneficiary-tabs'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { Routes } from '~/utils/routing/routes'

  definePageMeta({
    middleware: 'is-beneficiary-referent'
  })

  const {
    $loadMinimalBeneficiary,
    $loadOrganisationFollowUpTypes,
    $loadPrescribingOrganisations,
    $createItem,
    $snackbar
  } = useNuxtApp()
  const route = useRoute()

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const {
    data: beneficiary,
    pending: beneficiaryPending,
    error: beneficiaryError
  } = useLazyAsyncData(getRandomId('beneficiary'), loadBeneficiary, {
    server: false
  })

  const {
    data: followUpTypes,
    pending: followUpTypesPending,
    error: followUpTypesError
  } = useLazyAsyncData(
    getRandomId('followUpTypes'),
    $loadOrganisationFollowUpTypes,
    {
      server: false
    }
  )

  const {
    data: prescribingOrganisations,
    pending: prescribingOrganisationsPending,
    error: prescribingOrganisationsError
  } = useLazyAsyncData(
    getRandomId('prescribingOrganisations'),
    $loadPrescribingOrganisations,
    {
      server: false
    }
  )

  const pending = computed(
    () =>
      beneficiaryPending.value ||
      followUpTypesPending.value ||
      prescribingOrganisationsPending.value
  )

  const fetchError = computed(() => {
    if (beneficiaryError.value) {
      return "Les informations du bénéficiaire n'ont pas pu être chargées."
    }
    if (followUpTypesError.value) {
      return "La liste des types d'accompagnement de votre structure n'a pas pu être chargée."
    }
    if (prescribingOrganisationsError.value) {
      return "La liste des organismes prescripteurs de votre structure n'a pas pu être chargée."
    }
    return ''
  })

  const title = computed(() => {
    if (!beneficiary.value) return 'Entretien avec un·e bénéficiaire'
    return `Entretien avec ${beneficiaryName(beneficiary.value)}`
  })

  const beneficiaryId = computed(() => route.params.id)
  const beneficiaryHistoryPath = computed(
    () => `${Routes.Beneficiary(beneficiaryId.value)}?tab=${HISTORY_TAB}`
  )

  function loadBeneficiary() {
    return $loadMinimalBeneficiary(beneficiaryId.value)
  }

  async function onSaveInterview(interview) {
    isSubmitting.value = true
    try {
      const res = await $createItem('follow_ups', interview)

      if (res.status === 200) return navigateTo(beneficiaryHistoryPath.value)
      throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error("La création de la synthèse d'entretien a échoué.", () =>
        formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
